import * as React from 'react';
import React__default from 'react';
import PropTypes from 'prop-types';
import * as lodash from 'lodash';

declare class ValidatorComponent extends React__default.Component<any, any, any> {
    static getDerivedStateFromProps(nextProps: any, prevState: any): {
        value: any;
        validators: any;
        errorMessages: any;
    } | {
        value: any;
        validators?: undefined;
        errorMessages?: undefined;
    };
    constructor(props: any);
    constructor(props: any, context: any);
    state: {
        isValid: boolean;
        value: any;
        errorMessages: any;
        validators: any;
    };
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    componentDidUpdate(prevProps: any, prevState: any): void;
    componentWillUnmount(): void;
    getErrorMessage: () => any;
    instantValidate: boolean;
    invalid: any[];
    configure: () => void;
    debounceTime: any;
    validateDebounced: {
        (value?: any, includeRequired?: boolean | undefined, dryRun?: boolean | undefined): void;
        cancel: () => void;
    } | undefined;
    validate: (value: any, includeRequired?: boolean, dryRun?: boolean) => Promise<boolean>;
    isValid: () => boolean;
    makeInvalid: () => void;
    makeValid: () => void;
    renderComponent: (form: any) => any;
    form: any;
    render(): React__default.JSX.Element;
}
declare namespace ValidatorComponent {
    namespace propTypes {
        let errorMessages: PropTypes.Requireable<NonNullable<string | any[] | null | undefined>>;
        let validators: PropTypes.Requireable<any[]>;
        let value: PropTypes.Requireable<any>;
        let validatorListener: PropTypes.Requireable<(...args: any[]) => any>;
        let withRequiredValidator: PropTypes.Requireable<boolean>;
        let containerProps: PropTypes.Requireable<object>;
    }
    namespace defaultProps {
        let errorMessages_1: string;
        export { errorMessages_1 as errorMessages };
        let validators_1: never[];
        export { validators_1 as validators };
        export function validatorListener_1(): void;
        export { validatorListener_1 as validatorListener };
    }
}

declare class TextValidator extends ValidatorComponent {
    renderValidatorComponent(): React__default.JSX.Element;
}

declare class MuiSelect$1 extends ValidatorComponent {
    renderValidatorComponent(): React.JSX.Element;
}

declare class ValidatorForm extends React__default.Component<any, any, any> {
    static getValidator: (validator: any, value: any, includeRequired: any) => boolean;
    constructor(props: any);
    constructor(props: any, context: any);
    getFormHelpers: () => {
        form: {
            attachToForm: (component: any) => void;
            detachFromForm: (component: any) => void;
            instantValidate: any;
            debounceTime: any;
        };
    };
    instantValidate: any;
    debounceTime: any;
    childs: any[];
    errors: any[];
    attachToForm: (component: any) => void;
    detachFromForm: (component: any) => void;
    submit: (event: any) => void;
    walk: (children: any, dryRun: any) => Promise<any>;
    checkInput: (input: any, dryRun: any) => Promise<any>;
    validate: (input: any, includeRequired: any, dryRun: any) => Promise<any>;
    find: (collection: any, fn: any) => any;
    resetValidations: () => void;
    isFormValid: (dryRun?: boolean) => Promise<any>;
    render(): React__default.JSX.Element;
}
declare namespace ValidatorForm {
    function addValidationRule(name: any, callback: any): void;
    function getValidationRule(name: any): any;
    function hasValidationRule(name: any): any;
    function removeValidationRule(name: any): void;
    namespace propTypes {
        let onSubmit: PropTypes.Validator<(...args: any[]) => any>;
        let instantValidate: PropTypes.Requireable<boolean>;
        let children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        let onError: PropTypes.Requireable<(...args: any[]) => any>;
        let debounceTime: PropTypes.Requireable<number>;
    }
    namespace defaultProps {
        export function onError_1(): void;
        export { onError_1 as onError };
        let debounceTime_1: number;
        export { debounceTime_1 as debounceTime };
    }
}

declare class MaterialUiPhoneNumber extends React__default.Component<any, any, any> {
    constructor(props: any);
    flags: {};
    guessSelectedCountry: ((inputNumber: any, onlyCountries: any, defaultCountry: any) => any) & lodash.MemoizedFunction;
    state: {
        formattedNumber: any;
        placeholder: any;
        onlyCountries: any;
        preferredCountries: any[];
        defaultCountry: any;
        selectedCountry: any;
        highlightCountryIndex: number;
        queryString: string;
        freezeSelection: boolean;
        debouncedQueryStingSearcher: lodash.DebouncedFunc<() => void>;
        anchorEl: null;
    };
    componentDidMount(): void;
    componentDidUpdate({ value: prevValue }: {
        value: any;
    }): void;
    componentWillUnmount(): void;
    getProbableCandidate: ((queryString: any) => string | null) & lodash.MemoizedFunction;
    getOnlyCountries: (onlyCountriesArray: any, filteredCountries: any) => any;
    excludeCountries: (selectedCountries: any, excludedCountries: any) => any;
    filterRegions: (regions: any, filteredCountries: any) => any;
    deleteAreaCodes: (filteredCountries: any) => any;
    updateDefaultCountry: (country: any) => void;
    scrollTo: (country: any) => void;
    formatNumber: (text: any, patternArg: any) => any;
    cursorToEnd: () => void;
    getElement: (index: any) => any;
    getCountryData: () => {
        name?: undefined;
        dialCode?: undefined;
        countryCode?: undefined;
    } | {
        name: any;
        dialCode: any;
        countryCode: any;
    };
    handleInput: (e: any) => void;
    handleRefInput: (ref: any) => void;
    inputRef: any;
    handleInputClick: (e: any) => void;
    handleFlagItemClick: (country: any) => void;
    handleInputFocus: (e: any) => void;
    handleInputBlur: (e: any) => void;
    getHighlightCountryIndex: (direction: any) => any;
    searchCountry: () => void;
    handleKeydown: (e: any) => void;
    handleInputKeyDown: (e: any) => void;
    checkIfValid: () => any;
    updateFormattedNumber: (number: any) => void;
    getDropdownProps: () => {
        startAdornment?: undefined;
    } | {
        startAdornment: React__default.JSX.Element;
    };
    render(): React__default.JSX.Element;
}
declare namespace MaterialUiPhoneNumber {
    namespace propTypes {
        let excludeCountries: PropTypes.Requireable<(string | null | undefined)[]>;
        let onlyCountries: PropTypes.Requireable<(string | null | undefined)[]>;
        let preferredCountries: PropTypes.Requireable<(string | null | undefined)[]>;
        let defaultCountry: PropTypes.Requireable<string>;
        let value: PropTypes.Requireable<string>;
        let placeholder: PropTypes.Requireable<string>;
        let disabled: PropTypes.Requireable<boolean>;
        let error: PropTypes.Requireable<boolean>;
        let variant: PropTypes.Requireable<string>;
        let native: PropTypes.Requireable<boolean>;
        let inputClass: PropTypes.Requireable<string>;
        let dropdownClass: PropTypes.Requireable<string>;
        let InputProps: PropTypes.Requireable<object>;
        let inputProps: PropTypes.Requireable<object>;
        let inputRef: PropTypes.Requireable<(...args: any[]) => any>;
        let autoFormat: PropTypes.Requireable<boolean>;
        let disableAreaCodes: PropTypes.Requireable<boolean>;
        let disableCountryCode: PropTypes.Requireable<boolean>;
        let disableDropdown: PropTypes.Requireable<boolean>;
        let enableLongNumbers: PropTypes.Requireable<boolean>;
        let countryCodeEditable: PropTypes.Requireable<boolean>;
        let regions: PropTypes.Requireable<NonNullable<string | (string | null | undefined)[] | null | undefined>>;
        let localization: PropTypes.Requireable<object>;
        let onChange: PropTypes.Requireable<(...args: any[]) => any>;
        let onFocus: PropTypes.Requireable<(...args: any[]) => any>;
        let onBlur: PropTypes.Requireable<(...args: any[]) => any>;
        let onClick: PropTypes.Requireable<(...args: any[]) => any>;
        let onKeyDown: PropTypes.Requireable<(...args: any[]) => any>;
        let isValid: PropTypes.Requireable<(...args: any[]) => any>;
        let isModernBrowser: PropTypes.Requireable<(...args: any[]) => any>;
        let onEnterKeyPress: PropTypes.Requireable<(...args: any[]) => any>;
        let keys: PropTypes.Requireable<object>;
    }
    namespace defaultProps {
        let excludeCountries_1: never[];
        export { excludeCountries_1 as excludeCountries };
        let onlyCountries_1: never[];
        export { onlyCountries_1 as onlyCountries };
        let preferredCountries_1: never[];
        export { preferredCountries_1 as preferredCountries };
        let defaultCountry_1: string;
        export { defaultCountry_1 as defaultCountry };
        let placeholder_1: string;
        export { placeholder_1 as placeholder };
        let disabled_1: boolean;
        export { disabled_1 as disabled };
        let error_1: boolean;
        export { error_1 as error };
        let variant_1: string;
        export { variant_1 as variant };
        let native_1: boolean;
        export { native_1 as native };
        let inputClass_1: string;
        export { inputClass_1 as inputClass };
        let dropdownClass_1: string;
        export { dropdownClass_1 as dropdownClass };
        let autoFormat_1: boolean;
        export { autoFormat_1 as autoFormat };
        let disableAreaCodes_1: boolean;
        export { disableAreaCodes_1 as disableAreaCodes };
        export function isValid_1(inputNumber: any): boolean;
        export { isValid_1 as isValid };
        let disableCountryCode_1: boolean;
        export { disableCountryCode_1 as disableCountryCode };
        let disableDropdown_1: boolean;
        export { disableDropdown_1 as disableDropdown };
        let enableLongNumbers_1: boolean;
        export { enableLongNumbers_1 as enableLongNumbers };
        let countryCodeEditable_1: boolean;
        export { countryCodeEditable_1 as countryCodeEditable };
        let regions_1: string;
        export { regions_1 as regions };
        let localization_1: {};
        export { localization_1 as localization };
        export function onEnterKeyPress_1(): void;
        export { onEnterKeyPress_1 as onEnterKeyPress };
        export function onChange_1(): void;
        export { onChange_1 as onChange };
        export function isModernBrowser_1(): boolean;
        export { isModernBrowser_1 as isModernBrowser };
        export namespace keys_1 {
            let UP: number;
            let DOWN: number;
            let RIGHT: number;
            let LEFT: number;
            let ENTER: number;
            let ESC: number;
            let PLUS: number;
            let A: number;
            let Z: number;
            let SPACE: number;
        }
        export { keys_1 as keys };
    }
    let displayName: string;
}

declare const MuiTextField: typeof TextValidator;
declare const MuiPhoneNumber: typeof MaterialUiPhoneNumber;
declare const MuiSelect: typeof MuiSelect$1;
declare const MuiComponent: typeof ValidatorComponent;
declare const MuiForm: typeof ValidatorForm;

export { MuiComponent, MuiForm, MuiPhoneNumber, MuiSelect, MuiTextField };
